/*******************************(C) COPYRIGHT 2007 INSEM Inc.****************************************/
/* processor 	  : ARM966E-S					    				    */
/* compiler       : EWARM Compiler								    */
/* program by	  : JK.Won									    */
/* History:											    */
/* 04/13/2007     : Version 1.0									    */
/* copy right	  : Insem Inc.									    */
/****************************************************************************************************/
#define __STR91X_H__

#include "91x_lib.h"
#include "main.h"
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
TIM_InitTypeDef       Init_Structure;  
GPIO_InitTypeDef      GPIO_InitStructure;
UART_InitTypeDef      UART_InitStructure;
/******************************************************************************************************/
/* timer_setup : ش tmxfg "0"   ϴ timer  óѴ.		              */ 											
/******************************************************************************************************/
void timer_setup(uchar tmno, ushort timer) {
    clrbit(tm.slag, tmno);	timer_buf[tmno] =timer;
}
/******************************************************************************************************/
/* Internal_timer_Proc :  tmxfg ׻ "1" ̴	(timer_setup  tmxg "0" )	      */ 											
/******************************************************************************************************/
void Internal_timer_Proc() {				

  if(tm1ms_f) { tm1ms_f =0;	//every 1msec 
      if(!tm0fg) {	if(!--timer_buf[0]) tm0fg =1;	}		
      if(!tm1fg) {	if(!--timer_buf[1]) tm1fg =1;	}
      if(!tm2fg) {	if(!--timer_buf[2]) tm2fg =1;	}
      if(!tm3fg) {	if(!--timer_buf[3]) tm3fg =1;	}
      if(!tm4fg) {	if(!--timer_buf[4]) tm4fg =1;	}
      if(!tm5fg) {	if(!--timer_buf[5]) tm5fg =1;	}
      if(!tm6fg) {	if(!--timer_buf[6]) tm6fg =1;	}
      if(!tm7fg) {	if(!--timer_buf[7]) tm7fg =1;	} 
  }
}
/******************************************************************************************************/
/* timer base bit initial :		                                                              */																						
/******************************************************************************************************/
void Gp_initial(void){
    tm.slag =0xff;
}
/******************************************************************************************************/
/* PLL_initial	:	 Configures the system clocks.						      */												
/******************************************************************************************************/
void PLL_initial(void) {	//PLL configuration
/* flash memory remap */
  FMI_BankRemapConfig(4, 2, 0, 0x80000); /* Set Flash banks size & address */
  FMI_Config(FMI_READ_WAIT_STATE_2, FMI_WRITE_WAIT_STATE_0, FMI_PWD_ENABLE,\
           FMI_LVD_ENABLE, FMI_FREQ_HIGH); /* FMI Waite States */
  
/* PLL Cal : fPLL = (2 x N x fOSC)/(M x 2^P) = (2 x 192 x 25MHz)/(25 x 2^2)=96MHz */
/*  SCU_PLLFactorsConfig(N, M, P); */
  SCU_PLLFactorsConfig(192, 25, 2);     /* Configure Factors FPLL = 96MHz */
  SCU_PLLCmd(ENABLE);
  SCU_MCLKSourceConfig(SCU_MCLK_PLL);   // PLL = Main clock
  
//  SCU_RCLKDivisorConfig(SCU_RCLK_Div1);   // Reference clock divisor = 96MHz
//  SCU_HCLKDivisorConfig(SCU_HCLK_Div1);   // ARM high speed bus divisor = 96MHz
//  SCU_PCLKDivisorConfig(SCU_PCLK_Div1);   // ARM Peripheral bus divisor = 48MHz    

  SCU_AHBPeriphClockConfig(__VIC,ENABLE);    //give the clock to the peripheral.
  SCU_AHBPeriphReset(__VIC,ENABLE);          //Disable the Reset State.  

/* VIC configuration */
  VIC_DeInit();
}
/******************************************************************************************************/
/* Timer1_initial	:	TIMER 1 configuration   					      */												
/******************************************************************************************************/
void Timer1_initial(void) { 	
  /*Enable Clock for TIMER0,1*/
  SCU_APBPeriphClockConfig(__TIM01, ENABLE); //give the clock to the peripheral.(timer0,1)
  SCU_APBPeriphReset(__TIM01, ENABLE);       //Disable the Reset State.
  TIM_DeInit(TIM1);                          // TIM1 Deinitialization 
  
/* Initialize the Timer structure */
  TIM_StructInit(&Init_Structure);
  Init_Structure.TIM_Clock_Source = TIM_CLK_APB;
  Init_Structure.TIM_Prescaler = 95;          // timer clock = 1MHz

/* Enable the Timer Output compare interrupt */
  TIM_ITConfig(TIM1,  TIM_IT_OC1, ENABLE);

/* Initialize the Timer  */
  TIM_Init (TIM1, &Init_Structure);
  
/* timer1 interrupt enable */ 
  VIC_Config(TIM1_ITLine,VIC_IRQ,1);      
  VIC_ITCmd(TIM1_ITLine, ENABLE);  
  
/* Start the Timer counter */
  TIM_CounterCmd(TIM1, TIM_START);  
}
/******************************************************************************************************/
/* GPIO_port_initial	:								              */												
/******************************************************************************************************/
void GPIO_port_initial(void){
  /*Enable Clock for GPIO0*/
  SCU_APBPeriphClockConfig(__GPIO0,ENABLE);
  SCU_APBPeriphReset(__GPIO0,ENABLE);
  GPIO_DeInit(GPIO0);

  /*Enable Clock for GPIO1*/
  SCU_APBPeriphClockConfig(__GPIO1,ENABLE);
  SCU_APBPeriphReset(__GPIO1,ENABLE);  
   GPIO_DeInit(GPIO1); 
   
  /*Enable Clock for GPIO2*/
  SCU_APBPeriphClockConfig(__GPIO2,ENABLE);
  SCU_APBPeriphReset(__GPIO2,ENABLE);
  GPIO_DeInit(GPIO2);
  
   /*Enable Clock for GPIO3*/
  SCU_APBPeriphClockConfig(__GPIO3,ENABLE);
  SCU_APBPeriphReset(__GPIO3,ENABLE); 
  GPIO_DeInit(GPIO3); 
  
   /*Enable Clock for GPIO4*/
  SCU_APBPeriphClockConfig(__GPIO4,ENABLE);
  SCU_APBPeriphReset(__GPIO4,ENABLE);
  GPIO_DeInit(GPIO4);
  
  /*Enable Clock for GPIO5*/
  SCU_APBPeriphClockConfig(__GPIO5,ENABLE);
  SCU_APBPeriphReset(__GPIO5,ENABLE);
  GPIO_DeInit(GPIO5);
  
  /*Enable Clock for GPIO6*/
  SCU_APBPeriphClockConfig(__GPIO6,ENABLE);
  SCU_APBPeriphReset(__GPIO6,ENABLE);
  GPIO_DeInit(GPIO6);  
  
  /*Enable Clock for GPIO7*/
  SCU_APBPeriphClockConfig(__GPIO7,ENABLE);
  SCU_APBPeriphReset(__GPIO7,ENABLE);  
  GPIO_DeInit(GPIO7); 
  
  /*Enable Clock for GPIO8*/
  SCU_APBPeriphClockConfig(__GPIO8,ENABLE);
  SCU_APBPeriphReset(__GPIO8,ENABLE); 
  GPIO_DeInit(GPIO8); 
  
  /*Enable Clock for GPIO9*/
  SCU_APBPeriphClockConfig(__GPIO9,ENABLE);
  SCU_APBPeriphReset(__GPIO9,ENABLE);  
  GPIO_DeInit(GPIO9);
}

/******************************************************************************************************/
/* UART0_Initial	:																												*/												
/******************************************************************************************************/
void UART0_Initial(void) {
/////////////////////////////////////// question-Please write code ///////////////////////////////////////
// mission -6:  Uart 1 initial   port  Ͽ ͸ӳ windows ǥϽʽÿ!!
// Header File : ../include/91x_scu.h ,91x_gpio.h
//             : ../module/91x_scu.c ,91x_gpio.h 
//             : ../module/91x_uart.c ,91x_uart.h   
// Uart 0 Tx Line -> GPIO3.1 , Rx Line -> GPIO3.0  
// Uart 1 Tx Line -> GPIO3.3 , Rx Line -> GPIO3.2  
  
  /* Enable the UART0 Clock */
  SCU_APBPeriphClockConfig(__UART0, ENABLE);
  SCU_APBPeriphReset(__UART0,ENABLE);
  UART_DeInit(UART0);  
    
  /*Gonfigure UART0_Rx pin GPIO3.0*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinInput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Enable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_InputAlt1  ;
  GPIO_Init(GPIO3, &GPIO_InitStructure);
  
  /*Gonfigure UART0_Tx pin GPIO3.1*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinOutput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Disable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_OutputAlt2  ;
  GPIO_Init(GPIO3, &GPIO_InitStructure); 
  
  /* UART0 configuration -------------------------------------------------------*/
  /* UART0 configured as follow:
      - Word Length = 8 Bits
      - One Stop Bit
      - No parity
      - BaudRate = 115200 baud
      - Hardware flow control disable
      - Receive and transmit enabled
      - Receive and transmit FIFOs are enabled
      - Transmit and Receive FIFOs levels have 8 bytes depth
  */
  UART_InitStructure.UART_WordLength = UART_WordLength_8D;
  UART_InitStructure.UART_StopBits = UART_StopBits_1;
  UART_InitStructure.UART_Parity = UART_Parity_No ;
  UART_InitStructure.UART_BaudRate = 115200;
  UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;     // no flow controll
  UART_InitStructure.UART_Mode = UART_Mode_Tx_Rx;
  UART_InitStructure.UART_FIFO = UART_FIFO_Disable;  
  
  //  UART_InitStructure.UART_FIFO = UART_FIFO_Enable;
  //  UART_InitStructure.UART_TxFIFOLevel = UART_FIFOLevel_1_2; /* FIFO size 16 bytes, FIFO level 8 bytes */
  //  UART_InitStructure.UART_RxFIFOLevel = UART_FIFOLevel_1_2; /* FIFO size 16 bytes, FIFO level 8 bytes */
  //  UART_LoopBackConfig(UART0, DISABLE); 
  UART_Init(UART0, &UART_InitStructure);
  UART_ITConfig(UART0, UART_IT_Receive, ENABLE);    
 
  VIC_Config(UART0_ITLine, VIC_IRQ, 2);
  VIC_ITCmd(UART0_ITLine, ENABLE);  
    
  /* Enable the UART0 */
  UART_Cmd(UART0, ENABLE);
}
/******************************************************************************************************/
/* UART1_Initial	:																												*/												
/******************************************************************************************************/
void UART1_Initial(void) {
/////////////////////////////////////// question-Please write code ///////////////////////////////////////
// mission -6:  Uart 1 initial   port  Ͽ ͸ӳ windows ǥϽʽÿ!!
// Header File : ../include/91x_scu.h ,91x_gpio.h
//             : ../module/91x_scu.c ,91x_gpio.h 
//             : ../module/91x_uart.c ,91x_uart.h   
// Uart 0 Tx Line -> GPIO3.1 , Rx Line -> GPIO3.0  
// Uart 1 Tx Line -> GPIO3.3 , Rx Line -> GPIO3.2  
  
  /* Enable the UART0 Clock */
  SCU_APBPeriphClockConfig(__UART1, ENABLE);
  SCU_APBPeriphReset(__UART1,ENABLE);
  UART_DeInit(UART1);  
    
  /*Gonfigure UART0_Rx pin GPIO3.0*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinInput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Enable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_InputAlt1  ;
  GPIO_Init(GPIO3, &GPIO_InitStructure);
  
  /*Gonfigure UART0_Tx pin GPIO3.1*/
  GPIO_InitStructure.GPIO_Direction = GPIO_PinOutput;
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  GPIO_InitStructure.GPIO_Type = GPIO_Type_PushPull ;
  GPIO_InitStructure.GPIO_IPConnected = GPIO_IPConnected_Disable;
  GPIO_InitStructure.GPIO_Alternate = GPIO_OutputAlt2  ;
  GPIO_Init(GPIO3, &GPIO_InitStructure); 
  
  /* UART0 configuration -------------------------------------------------------*/
  /* UART0 configured as follow:
      - Word Length = 8 Bits
      - One Stop Bit
      - No parity
      - BaudRate = 115200 baud
      - Hardware flow control disable
      - Receive and transmit enabled
      - Receive and transmit FIFOs are enabled
      - Transmit and Receive FIFOs levels have 8 bytes depth
  */
  UART_InitStructure.UART_WordLength = UART_WordLength_8D;
  UART_InitStructure.UART_StopBits = UART_StopBits_1;
  UART_InitStructure.UART_Parity = UART_Parity_No ;
  UART_InitStructure.UART_BaudRate = 115200;
  UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;     // no flow controll
  UART_InitStructure.UART_Mode = UART_Mode_Tx_Rx;
  UART_InitStructure.UART_FIFO = UART_FIFO_Disable;  
  
  //  UART_InitStructure.UART_FIFO = UART_FIFO_Enable;
  //  UART_InitStructure.UART_TxFIFOLevel = UART_FIFOLevel_1_2; /* FIFO size 16 bytes, FIFO level 8 bytes */
  //  UART_InitStructure.UART_RxFIFOLevel = UART_FIFOLevel_1_2; /* FIFO size 16 bytes, FIFO level 8 bytes */
  //  UART_LoopBackConfig(UART0, DISABLE); 
  UART_Init(UART1, &UART_InitStructure);
  UART_ITConfig(UART1, UART_IT_Receive, ENABLE);    
 
  VIC_Config(UART1_ITLine, VIC_IRQ, 3);
  VIC_ITCmd(UART1_ITLine, ENABLE);  
    
  /* Enable the UART0 */
  UART_Cmd(UART1, ENABLE);
}
/******************************************************************************************************/
/* ARM_initial	:		        							      */												
/******************************************************************************************************/
void ARM_initial(void) {
  PLL_initial();		// PLL Initial
  GPIO_port_initial();		// gpio initial
  Timer1_initial();		// timer 1 Initial	
  UART0_Initial();              // Uart 0  initial  
  UART1_Initial();              // Uart 1  initial  
  Gp_initial();			// general timer flag initial
}
/******************* (C) COPYRIGHT 2007 INSEM Inc ***************************************END OF FILE****/


