/*******************************(C) COPYRIGHT 2007 INSEM Inc.****************************************/
/* processor 	  : ARM966E-S					    				    */
/* compiler       : EWARM Compiler								    */
/* program by	  : JK.Won									    */
/* History:											    */
/* 04/13/2007     : Version 1.0									    */
/* copy right	  : Insem Inc.									    */
/****************************************************************************************************/
#define __UART0_H__

#include "91x_lib.h"
#include "main.h"
/******************************************************************************************************/
/* byte_loading	:									              */												
/******************************************************************************************************/
uchar byte_loading() {
  if(ring.ldad !=ring.svad) {
    spdata =ring.buf[ring.ldad];
    if(++ring.ldad >=sizeof(ring.buf)) ring.ldad =0;
    return 1;
  }
  return 0;
}
/******************************************************************************************************/
/* dbg_put_char	:			                					      */												
/******************************************************************************************************/
void dbg_put_char(uchar dat) {
    UART0->DR = dat;
    while (UART_GetFlagStatus(UART0, UART_FLAG_TxFIFOFull) != RESET);
}
/******************************************************************************************************/
/* put_str	:									              */												
/******************************************************************************************************/
void put_str(const char *str) {
uchar i;
  for(i=0;i<strlen(str);i++) {
    dbg_put_char(str[i]);
  }
}
/******************************************************************************************************/
/* ascii2hex_conv	:									      */												
/******************************************************************************************************/
uchar ascii2hex_conv(uchar dat) {
  if(dat <= 0x39) {   //0~9
          dat = dat-0x30;
  }else if(0x41<=dat && dat<=0x46) {//A~F
          dat = dat-0x37;
  }else if(0x61<=dat && dat<=0x66) {//a~f
          dat = dat-0x57;
  }
  return dat;
}
/******************************************************************************************************/
/* UART0_control_proc	:									      */												
/******************************************************************************************************/
uchar uartctrl =7;
uchar keyin;
void UART0_control_proc(void) {
  switch(uartctrl) {
    case 0:
      if(byte_loading()) {	
        sprintf(dbug,"%c",spdata);     out(); 
      }

    break;
    // powerup start
    case 7:       uartctrl =0;	    break;                                            
  }
}
/******************* (C) COPYRIGHT 2007 INSEM Inc ***************************************END OF FILE****/
